From 951c354472ae14af34a6a034ff0f79376cd085ed Mon Sep 17 00:00:00 2001
From: "Jasper St. Pierre" <jstpierre@mecheye.net>
Date: Wed, 12 Aug 2015 16:04:31 -0700
Subject: [PATCH] Port to duktape

---
 configure.ac                                    |   15 -
 src/polkitbackend/Makefile.am                   |    7 +-
 src/polkitbackend/duktape.c                     |72690 +++++++++++++++++++++++
 src/polkitbackend/duktape.h                     | 4460 ++
 src/polkitbackend/polkitbackendjsauthority.c    |  846 +-
 test/data/etc/polkit-1/rules.d/10-testing.rules |    2 +-
 6 files changed, 77329 insertions(+), 691 deletions(-)
 create mode 100644 src/polkitbackend/duktape.c
 create mode 100644 src/polkitbackend/duktape.h

diff --git a/configure.ac b/configure.ac
index 85f26b9..29758be 100644
--- a/configure.ac
+++ b/configure.ac
@@ -129,21 +129,6 @@ AC_DEFINE([GLIB_VERSION_MIN_REQUIRED], [GLIB_VERSION_2_30],
 AC_DEFINE([GLIB_VERSION_MAX_ALLOWED], [G_ENCODE_VERSION(2,34)],
         [Notify us when we'll need to transition away from g_type_init()])
 
-AC_ARG_WITH(mozjs, AS_HELP_STRING([--with-mozjs=@<:@mozjs185/mozjs-17.0|auto@:>@],
-		                  [Specify version of Spidermonkey to use]),,
-            with_mozjs=auto)
-AS_IF([test x${with_mozjs} != xauto], [
-  PKG_CHECK_MODULES(LIBJS, ${with_mozjs})
-], [
-  PKG_CHECK_MODULES(LIBJS, [mozjs185], have_mozjs185=yes, have_mozjs185=no)
-  AS_IF([test x${have_mozjs185} = xno], [
-  PKG_CHECK_MODULES(LIBJS, [mozjs-17.0], have_mozjs17=yes,
-   [AC_MSG_ERROR([Could not find mozjs185 or mozjs-17.0; see http://ftp.mozilla.org/pub/mozilla.org/js/])])
-  ])
-])
-AC_SUBST(LIBJS_CFLAGS)
-AC_SUBST(LIBJS_LIBS)
-
 EXPAT_LIB=""
 AC_ARG_WITH(expat, [  --with-expat=<dir>      Use expat from here],
                       [
diff --git a/src/polkitbackend/Makefile.am b/src/polkitbackend/Makefile.am
index 547ca82..ef6a9dd 100644
--- a/src/polkitbackend/Makefile.am
+++ b/src/polkitbackend/Makefile.am
@@ -36,6 +36,7 @@ libpolkit_backend_1_la_SOURCES =                                   			\
 	polkitbackendactionpool.h		polkitbackendactionpool.c		\
 	polkitbackendconfigsource.h		polkitbackendconfigsource.c		\
 	polkitbackendactionlookup.h		polkitbackendactionlookup.c		\
+	duktape.c duktape.h \
         $(NULL)
 
 if HAVE_LIBSYSTEMD
@@ -49,9 +50,11 @@ endif
 libpolkit_backend_1_la_CFLAGS =                                        	\
         -D_POLKIT_COMPILATION                                  		\
         -D_POLKIT_BACKEND_COMPILATION                                  	\
+	-DDUK_OPT_HAVE_CUSTOM_H						\
+	-DDUK_OPT_INTERRUPT_COUNTER					\
+	-D'DUK_OPT_EXEC_TIMEOUT_CHECK(u)=polkit_js_exec_timeout_check(u)' \
         $(GLIB_CFLAGS)							\
 	$(LIBSYSTEMD_CFLAGS)						\
-	$(LIBJS_CFLAGS)							\
         $(NULL)
 
 libpolkit_backend_1_la_LIBADD =                               		\
@@ -59,7 +62,7 @@ libpolkit_backend_1_la_LIBADD =                               		\
 	$(LIBSYSTEMD_LIBS)						\
 	$(top_builddir)/src/polkit/libpolkit-gobject-1.la		\
 	$(EXPAT_LIBS)							\
-	$(LIBJS_LIBS)							\
+	-lm								\
         $(NULL)
 
 rulesdir = $(sysconfdir)/polkit-1/rules.d
